package org.dromara.art.service.impl;

import org.dromara.common.core.utils.MapstructUtils;
import org.dromara.common.core.utils.StringUtils;
import org.dromara.common.mybatis.core.page.TableDataInfo;
import org.dromara.common.mybatis.core.page.PageQuery;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import lombok.RequiredArgsConstructor;
import lombok.extern.slf4j.Slf4j;
import org.springframework.stereotype.Service;
import org.dromara.art.domain.bo.ArtSchoolTagBo;
import org.dromara.art.domain.vo.ArtSchoolTagVo;
import org.dromara.art.domain.ArtSchoolTag;
import org.dromara.art.mapper.ArtSchoolTagMapper;
import org.dromara.art.service.IArtSchoolTagService;

import java.util.List;
import java.util.Map;
import java.util.Collection;

/**
 * 学校标签Service业务层处理
 *
 * @author ZhouWenTao
 * @date 2026-02-17
 */
@Slf4j
@RequiredArgsConstructor
@Service
public class ArtSchoolTagServiceImpl implements IArtSchoolTagService {

    private final ArtSchoolTagMapper baseMapper;

    /**
     * 查询学校标签
     *
     * @param schoolTagId 主键
     * @return 学校标签
     */
    @Override
    public ArtSchoolTagVo queryById(Long schoolTagId){
        return baseMapper.selectVoById(schoolTagId);
    }

    /**
     * 分页查询学校标签列表
     *
     * @param bo        查询条件
     * @param pageQuery 分页参数
     * @return 学校标签分页列表
     */
    @Override
    public TableDataInfo<ArtSchoolTagVo> queryPageList(ArtSchoolTagBo bo, PageQuery pageQuery) {
        LambdaQueryWrapper<ArtSchoolTag> lqw = buildQueryWrapper(bo);
        Page<ArtSchoolTagVo> result = baseMapper.selectVoPage(pageQuery.build(), lqw);
        return TableDataInfo.build(result);
    }

    /**
     * 查询符合条件的学校标签列表
     *
     * @param bo 查询条件
     * @return 学校标签列表
     */
    @Override
    public List<ArtSchoolTagVo> queryList(ArtSchoolTagBo bo) {
        LambdaQueryWrapper<ArtSchoolTag> lqw = buildQueryWrapper(bo);
        return baseMapper.selectVoList(lqw);
    }

    private LambdaQueryWrapper<ArtSchoolTag> buildQueryWrapper(ArtSchoolTagBo bo) {
        Map<String, Object> params = bo.getParams();
        LambdaQueryWrapper<ArtSchoolTag> lqw = Wrappers.lambdaQuery();
        lqw.orderByAsc(ArtSchoolTag::getSchoolTagId);
        lqw.eq(bo.getSchoolId() != null, ArtSchoolTag::getSchoolId, bo.getSchoolId());
        lqw.like(StringUtils.isNotBlank(bo.getTagName()), ArtSchoolTag::getTagName, bo.getTagName());
        return lqw;
    }

    /**
     * 新增学校标签
     *
     * @param bo 学校标签
     * @return 是否新增成功
     */
    @Override
    public Boolean insertByBo(ArtSchoolTagBo bo) {
        ArtSchoolTag add = MapstructUtils.convert(bo, ArtSchoolTag.class);
        validEntityBeforeSave(add);
        boolean flag = baseMapper.insert(add) > 0;
        if (flag) {
            bo.setSchoolTagId(add.getSchoolTagId());
        }
        return flag;
    }

    /**
     * 修改学校标签
     *
     * @param bo 学校标签
     * @return 是否修改成功
     */
    @Override
    public Boolean updateByBo(ArtSchoolTagBo bo) {
        ArtSchoolTag update = MapstructUtils.convert(bo, ArtSchoolTag.class);
        validEntityBeforeSave(update);
        return baseMapper.updateById(update) > 0;
    }

    /**
     * 保存前的数据校验
     */
    private void validEntityBeforeSave(ArtSchoolTag entity){
        //TODO 做一些数据校验,如唯一约束
    }

    /**
     * 校验并批量删除学校标签信息
     *
     * @param ids     待删除的主键集合
     * @param isValid 是否进行有效性校验
     * @return 是否删除成功
     */
    @Override
    public Boolean deleteWithValidByIds(Collection<Long> ids, Boolean isValid) {
        if(isValid){
            //TODO 做一些业务上的校验,判断是否需要校验
        }
        return baseMapper.deleteByIds(ids) > 0;
    }
}
